import React, { Component } from 'react';
import { Link } from "react-router-dom";

import * as routes from './../../../constants/routes';
import token from './../../../utils/token';

export default class header extends Component {
    /*
        TODO: 
        - add toggler for admin panel
        - disable marking and background hover effect in the nav panel 
    */

    state = {
        navTogglerClosed: true,
        adminToggleClosed: true
    }

    handleLinkClick = () => {
        this.setState({ togglerClosed: true })
    }

    handleNavToggle = () => {
        this.setState((prevState) => ({ navTogglerClosed: !prevState.navTogglerClosed }))
    }

    handleAdminToggle = () => {
        this.setState({

        })
    }

    handleSignOut = () => {
        this.props.signOut();
        localStorage.removeItem(token);
    }

    render() {
        const { navTogglerClosed, adminToggleClosed } = this.state;
        const { user: { data } } = this.props;
        const navToggleStatus = navTogglerClosed ? "nav-toggle-status--closed" : "nav-toggle-status--opened";
        const adminToggleStatus = adminToggleClosed ? "admin-toggle-status--closed" : "admin-toggle-status--opened";

        return (
            <header className="header">
                <Link onClick={this.handleLinkClick} to={routes.LANDING}>
                    <h1 className="header__logo">Test.<span className="header__logo--i-letter">i</span>o</h1>
                </Link>
                <hr className="header__logo--divider" />
                <span className="header__toggle-trigger" onClick={this.handleNavToggle} >
                    <span />
                </span>
                <div className="header__flex-wrapper">
                    <nav className={`header__nav ${navToggleStatus}`}>
                        <ul className="header__nav nav__list">
                            <li>
                                <Link onClick={this.handleLinkClick} className="header__nav nav__list-item" to={routes.HOME}>
                                    Home
                                </Link>
                            </li>
                            <li>
                                <Link onClick={this.handleLinkClick} className="header__nav nav__list-item" to={routes.PROFILE}>
                                    Profile
                                </Link>
                            </li>
                            <li>
                                <Link onClick={this.handleLinkClick} className="header__nav nav__list-item" to={routes.TESTS}>
                                    Test
                                </Link>
                            </li>
                            <li>
                                <Link onClick={this.handleLinkClick} className="header__nav nav__list-item" to={routes.CATEGORIES}>
                                    Categories
                                </Link>
                            </li>
                            {
                                data && data.is_admin && (
                                    <div className={`header__nav ${adminToggleStatus}`}>
                                        <li>
                                            <Link onClick={this.handleLinkClick} className="header__nav nav__list-item--admin-only" to={routes.CREATE_TEST}>
                                                Create test
                                            </Link>
                                        </li>
                                        <li>
                                            <Link onClick={this.handleLinkClick} className="header__nav nav__list-item--admin-only" to={routes.CREATE_CATEGORY}>
                                                Create category
                                            </Link>
                                        </li>
                                        <li>
                                            <Link onClick={this.handleLinkClick} className="header__nav nav__list-item--admin-only" to={routes.DELETE_USER}>
                                                Delete data
                                            </Link>
                                        </li>
                                    </div>
                                )
                            }
                        </ul>
                    </nav>

                    <div className="header__links">
                        {
                            !data
                                ? (
                                    <React.Fragment>
                                        <Link onClick={this.handleLinkClick} className="header__links--sign-in link--btn link--btn25" to={routes.SIGN_IN}>Sign in</Link>
                                        <Link onClick={this.handleLinkClick} className="header__links--sign-up link--btn link--btn25" to={routes.SIGN_UP}>Sign up</Link>
                                    </React.Fragment>
                                )
                                : (
                                    <button
                                        className="header__links--sign-in link--btn link--btn25"
                                        onClick={this.handleSignOut}
                                    >
                                        Sign out
                                    </button>
                                )
                        }
                    </div>
                </div>
            </header>
        )
    }
}