import React from 'react';
import { Link } from 'react-router-dom';
import { HOME } from './../../../constants/routes';
import Spinner from './../../common/spinner'

export default class NotFound extends React.Component {
    state = {
        isLoading: true
    }

    componentDidMount() {
        const image = new Image();
        image.src = 'http://kiwanismiracleleague.org/wp-content/themes/chillibox/media/images/404.png'
        image.onload = () => this.setState({
            isLoading: false
        })
    }

    render() {
        const { isLoading } = this.state;

        return (
            isLoading
                ?
                <Spinner />
                :
                <div className="page not-found">
                    <img className="not-found__image" src="http://kiwanismiracleleague.org/wp-content/themes/chillibox/media/images/404.png" alt="404" />
                    <hr className="not-found__divider" />
                    <h1 className="not-found__message">Sorry, but looks like nobody lives here...</h1>
                    <p><Link className="link--btn link--btn-big not-found__link--home" to={HOME}>Go home</Link></p>
                </div>
        )
    }
}
